//  A0Connection.m
//
// Copyright (c) 2014 Auth0 (http://auth0.com)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#import "A0Connection.h"

NSString * const A0ConnectionRequiresUsername = @"requires_username";
NSString * const A0ConnectionDomain = @"domain";
NSString * const A0ConnectionDomainAliases = @"domain_aliases";
NSString * const A0ConnectionShowForgot = @"showForgot";
NSString * const A0ConnectionShowSignUp = @"showSignup";

@interface A0Connection ()

@property (strong, nonatomic) NSDictionary *values;

@end

@implementation A0Connection

- (instancetype)initWithJSONDictionary:(NSDictionary *)JSON {
    self = [super init];
    if (self) {
        NSAssert([JSON[@"name"] length] > 0, @"Must have a valid name");
        _values = [NSDictionary dictionaryWithDictionary:JSON];
    }
    return self;
}

- (NSString *)name {
    return self.values[@"name"];
}

- (nullable id)objectForKeyedSubscript:(NSString *)key {
    return self.values[key];
}

- (NSString *)description {
    return [NSString stringWithFormat:@"<A0Connection name = %@; values %@>", self.values[@"name"], self.values];
}
@end
